//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
#define bit0 0
#define bit1 1
#define byte unsigned char
//---------------------------------------------------------------------------

#define xmax 100
#define ymax 100
#define zmax 100

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TBitBtn *BitBtn1;
	TBitBtn *BitBtn2;
	TLabel *Label1;
	TEdit *Edit1;
	TLabel *Label2;
	TLabel *Label5;
	TBitBtn *BitBtn3;
	void __fastcall BitBtn1Click(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall BitBtn3Click(TObject *Sender);
private:	// User declarations
	byte 	neuron[1000000];
    int		iteration;

public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
	void __fastcall MainLoop(TObject* Sender, bool& Done);
    bool __fastcall IterateNeuralNetwork();
    bool __fastcall SetAllNeurons( byte value );
    bool __fastcall LoadNeuronsFromFile( AnsiString filename );
    bool __fastcall SetNeuron( int x, int y, int z, byte value );
    byte __fastcall GetNeuron( int x, int y, int z );
    void __fastcall PaintNeurons( int z );
    void __fastcall FireNeuron( int x, int y, int z );
};
//---------------------------------------------------------------------------
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
